

--133 - fire ball 35 yards
--5176	Wrath 30
--1978	Serpent Sting 25 yrd
--
--591 smite 30 yrd
--26679 deadly throw 30 yd
--403 Lighting bolt 30 yd
--686 Shadow bold 30 yd
local L = LibStub("AceLocale-3.0"):GetLocale("ProximoGrid", true)
StatusRange = ProximoGridStatus.NewModule("StatusRange", {
	color = {1, 1, 1, 0.5},
	priority = 90,
});

StatusRange.header = L["Not in Range"];
StatusRange.options = {
	color = {
		type = "color",
		name = L["Color"],
		desc = L["Color."],
		get = function()
			local tmpColor = StatusRange.db.color;
			return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
		end,
		set = function(r, g, b, a)
			local tmpColor = StatusRange.db.color;
			tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
		end,
		hasAlpha = false,
	},
	alpha = {
		type = "range",
		name = L["Alpha"],
		desc = L["Alpha."],
		get = function()
			return StatusRange.db.color[4];
		end,
		set = function(v)
			StatusRange.db.color[4] = v;
		end,
		min = 0,
		max = 1,
		step = 0.01
	},
	priority = {
		type = "range",
		name = L["Priority"],
		desc = L["Priority."],
		get = function()
			return StatusRange.db.priority;
		end,
		set = function(v)
			StatusRange.db.priority = v;
		end,
		min = 1,
		max = 99,
		step = 1
	},

}
StatusRange.checkSpell = 0;

StatusRange.updateFrame = CreateFrame("frame");

function StatusRange:OnInitialize()
	local _,playerClass = UnitClass("player");
	if (playerClass == "DRUID") then
		tmpSpell = GetSpellInfo(5176);
	elseif (playerClass == "HUNTER") then
		tmpSpell = GetSpellInfo(1978);
	elseif (playerClass == "MAGE") then
		tmpSpell = GetSpellInfo(133);
	elseif (playerClass == "PALADIN") then
		tmpSpell = GetSpellInfo(24275);
	elseif (playerClass == "PRIEST") then
		tmpSpell = GetSpellInfo(591);
	elseif (playerClass == "ROGUE") then
		tmpSpell = GetSpellInfo(26679);
	elseif (playerClass == "SHAMAN") then
		tmpSpell = GetSpellInfo(403);
	elseif (playerClass == "WARLOCK") then
		tmpSpell = GetSpellInfo(686);
	elseif (playerClass == "WARRIOR") then
		tmpSpell = GetSpellInfo(57755);
	elseif (playerClass == "Deathknight") then
		tmpSpell = GetSpellInfo(52375);
	end
	
	if (tmpSpell) then
		StatusRange.checkSpell = tmpSpell;
	else
		StatusRange.checkSpell = 0;
	end
	if (StatusRange.checkSpell ~= 0) then
		StatusRange:RegisterStatus("statusRange", L["Not in Range"]);
	end
end

function StatusRange:OnEnable()
	if (ProximoGrid:inArenaZone()) then
		StatusRange.updateFrame:SetScript("OnUpdate", StatusRange.OnUpdate);
	end
end

function StatusRange:OnDisable()
	StatusRange.updateFrame:SetScript("OnUpdate", nil);
end

StatusRange.lastUpdate = 0;
function StatusRange:OnUpdate()
	if (StatusRange.lastUpdate+0.2 < GetTime()) then
		for i=1, ProximoGrid:GetRows()*ProximoGrid:GetColumns() do
			if (ProximoGrid.Opponents["arena"..i]~=nil) then
				if ( IsSpellInRange(StatusRange.checkSpell, "arena"..i) ~= nil and IsSpellInRange(StatusRange.checkSpell, "arena"..i) == 0) then
					local tmpColor = StatusRange.db.color;
					local r, g, b, a = tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4];
					StatusRange:SendStatusGained("arena"..i, unitName, "statusRange", StatusRange.db.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, L["Out of Range"],  0, 0, nil, 0, 0, 0);
				else
					StatusRange:SendStatusLost("arena"..i, "statusRange");
				end
			end
		end
		StatusRange.lastUpdate = GetTime();
	end
end